# Method: changes.list

- [HTTP request](https://developers.google.com/workspace/drive/api/reference/rest/v2/changes/list#body.HTTP_TEMPLATE)
- [Query parameters](https://developers.google.com/workspace/drive/api/reference/rest/v2/changes/list#body.QUERY_PARAMETERS)
- [Request body](https://developers.google.com/workspace/drive/api/reference/rest/v2/changes/list#body.request_body)
- [Response body](https://developers.google.com/workspace/drive/api/reference/rest/v2/changes/list#body.response_body)
  - [JSON representation](https://developers.google.com/workspace/drive/api/reference/rest/v2/changes/list#body.ChangeList.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://developers.google.com/workspace/drive/api/reference/rest/v2/changes/list#body.aspect)
- [Try it!](https://developers.google.com/workspace/drive/api/reference/rest/v2/changes/list#try-it)

Lists the changes for a user or shared drive.

### HTTP request

`GET https://www.googleapis.com/drive/v2/changes`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Query parameters

| Parameters ||
|---|---|
| `driveId` | `string` The shared drive from which changes will be returned. If specified the change IDs will be reflective of the shared drive; use the combined drive ID and change ID as an identifier. |
| `includeCorpusRemovals` | `boolean` Whether changes should include the file resource if the file is still accessible by the user at the time of the request, even when a file was removed from the list of changes and there will be no further change entries for this file. |
| `includeDeleted` | `boolean` Whether to include changes indicating that items have been removed from the list of changes, for example by deletion or loss of access. |
| `includeItemsFromAllDrives` | `boolean` Whether both My Drive and shared drive items should be included in results. |
| `includeSubscribed` | `boolean` Whether to include changes outside the My Drive hierarchy in the result. When set to false, changes to files such as those in the Application Data folder or shared files which have not been added to My Drive will be omitted from the result. |
| `includeTeamDriveItems (deprecated)` | `boolean` Deprecated: Use `includeItemsFromAllDrives` instead. |
| `maxResults` | `integer` Maximum number of changes to return. |
| `pageToken` | `string` The token for continuing a previous list request on the next page. This should be set to the value of `nextPageToken` from the previous response or to the response from the getStartPageToken method. |
| `spaces` | `string` A comma-separated list of spaces to query. Supported values are `drive`, `appDataFolder` and `photos`. |
| `startChangeId (deprecated)` | `string (https://developers.google.com/discovery/v1/type-format format)` Deprecated: Use `pageToken` instead. |
| `supportsAllDrives` | `boolean` Whether the requesting application supports both My Drives and shared drives. |
| `supportsTeamDrives (deprecated)` | `boolean` Deprecated: Use `supportsAllDrives` instead. |
| `teamDriveId (deprecated)` | `string` Deprecated: Use `driveId` instead. |
| `includePermissionsForView` | `string` Specifies which additional view's permissions to include in the response. Only `published` is supported. |
| `includeLabels` | `string` A comma-separated list of IDs of labels to include in the `labelInfo` part of the response. |

### Request body

The request body must be empty.

### Response body

A list of changes for a user.

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "items": [ { object (`https://developers.google.com/workspace/drive/api/reference/rest/v2/changes#Change`) } ], "largestChangeId": string, "nextPageToken": string, "kind": string, "etag": string, "newStartPageToken": string, "selfLink": string, "nextLink": string } ``` |

| Fields ||
|---|---|
| `items[]` | ``object (`https://developers.google.com/workspace/drive/api/reference/rest/v2/changes#Change`)`` The list of changes. If nextPageToken is populated, then this list may be incomplete and an additional page of results should be fetched. |
| `largestChangeId` | `string (https://developers.google.com/discovery/v1/type-format format)` The current largest change ID. |
| `nextPageToken` | `string` The page token for the next page of changes. This will be absent if the end of the changes list has been reached. If the token is rejected for any reason, it should be discarded, and pagination should be restarted from the first page of results. |
| `kind` | `string` This is always `drive#changeList`. |
| `etag` | `string` The ETag of the list. |
| `newStartPageToken` | `string` The starting page token for future changes. This will be present only if the end of the current changes list has been reached. |
| `selfLink` | `string` A link back to this list. |
| `nextLink` | `string` A link to the next page of changes. |

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/docs`
- `
  https://www.googleapis.com/auth/drive`
- `
  https://www.googleapis.com/auth/drive.appdata`
- `
  https://www.googleapis.com/auth/drive.apps.readonly`
- `
  https://www.googleapis.com/auth/drive.file`
- `
  https://www.googleapis.com/auth/drive.meet.readonly`
- `
  https://www.googleapis.com/auth/drive.metadata`
- `
  https://www.googleapis.com/auth/drive.metadata.readonly`
- `
  https://www.googleapis.com/auth/drive.photos.readonly`
- `
  https://www.googleapis.com/auth/drive.readonly`

Some scopes are restricted and require a security assessment for your app to use them. For more information, see the [Authorization guide](https://developers.google.com/workspace/guides/configure-oauth-consent).